
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用Acorn来解析JavaScript / iVAN</title>

    <meta name="description" content="使用Acorn来解析JavaScript Talk 因为最近工作上有需要使用解析 JavaScript 的代码,大部分情况使用正则表达式匹配就可以处理,但是一旦依赖于代码上下文的内容时,正则或者简单的字符解析就很力不从心了,这个时候需要一个语言解析器来获取整一个 AST(abstract syntax tree). 然后我找到了多个使用 JavaScript 编写的 JavaScript 解析器: Esprima Acorn UglifyJS 2 Shift 从提交记录来看,维护情况都蛮好的,ES 各种发展的特性都跟得上,我分别都简单了">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用Acorn来解析JavaScript</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczQuNTFjdG8uY29tL3d5ZnMwMi9NMDEvOEEvMjkvd0tpb0wxZ3BvTG5oX0p6SUFBRlN4TG95LVJFOTk3LmpwZy13aF82NTF4LXNfMjA5ODA1MTQwNS5qcGc=.jpg"></p>
<p><strong>Talk</strong></p>
<p>因为最近工作上有需要使用解析 JavaScript<br />
的代码，大部分情况使用正则表达式匹配就可以处理，但是一旦依赖于代码上下文的内容时，正则或者简单的字符解析就很力不从心了，这个时候需要一个语言解析器来获取整一个<br />
  AST(abstract syntax tree)。</p>
<p>然后我找到了多个使用 JavaScript 编写的 JavaScript 解析器：</p>
<ul>
<li>Esprima</li>
<li>Acorn</li>
<li>UglifyJS 2</li>
<li>Shift</li>
</ul>
<p>从提交记录来看，维护情况都蛮好的，ES 各种发展的特性都跟得上，我分别都简单了解了一下，聊聊他们的一些情况。</p>
<p>&lt;!--more--&gt;</p>
<p>Esprima 是很经典的一个解析器，Acorn 在它之后诞生，都是几年前的事情了。按照 Acorn<br />
作者的说法，当时造这个轮子更多只是好玩，速度可以和  Esprima 媲美，但是实现代码更少。其中比较关键的点是这两个解析器出来的 AST<br />
结果(对，只是 AST，tokens 不一样)都是符合 The  Estree Spec 规范(这是 Mozilla 的工程师给出的<br />
SpiderMonkey 引擎输出的 JavaScript AST  的规范文档，也可以参考：SpiderMonkey in<br />
MDN)的，也就是得到的结果在很大部分上是兼容的。</p>
<p>现在很出名的 Webpack 解析代码时用的也是 Acorn。</p>
<p>至于 Uglify，很出名的一个 JavaScript 代码压缩器，其实它自带了一个代码解析器，也可以输出  AST，但是它的功能更多还是用于压缩代码，如果拿来解析代码感觉不够纯粹。</p>
<p>Shift 这个没做多少了解，只知道他定义了自己的一套 AST 规范。</p>
<p>Esprima 官网上有一个性能测试，我在 chrome 上跑的结果如下：</p>
<p>&lt;img src="<a href="http://ww1.sinaimg.cn/images/bad_req.html" rel="external nofollow noreferrer">http://ww1.sinaimg.cn/large/0...</a> alt="性能测试"  style="width:100%;"&gt;</p>
<p>可见，Acorn 的性能很不错，而且还有一个 Estree 的规范呢(规范很重要，我个人觉得遵循通用的规范是代码复用的重要基础)，所以我就直接选用  Acorn 来做代码解析了。</p>
<p>图中做性能对比的还有 Google 的 Traceur，它更多是一个 ES6 to ES5 的 compiler，于我们想要找的解析器定位不符。</p>
<p>下面进入正题，如何使用 Acorn 来解析 JavaScript。</p>
<p><strong>API</strong></p>
<p>解析器的 API 都是很简单的：</p>
<pre>
</pre>
<ol>
<li>const ast = acorn.parse(code, options) </li>
</ol>
<p>Acorn 的配置项蛮多的，里边还包括了一些事件可以设置回调函数。我们挑几个比较重要的讲下：</p>
<ul>
<li>ecmaVersion</li>
</ul>
<p>字面意义，很好理解，就是设置你要解析的 JavaScript 的 ECMA 版本。默认是 ES7。</p>
<ul>
<li>sourceType</li>
</ul>
<p>这个配置项有两个值：module 和 script，默认是 script。</p>
<p>主要是严格模式和 import/export 的区别。ES6 中的模块是严格模式，也就是你无须添加 use strict。我们通常浏览器中使用的  script 是没有 import/export 语法的。</p>
<p>所以，选择了 script 则出现 import/export 会报错，可以使用严格模式声明，选择了  module，则不用严格模式声明，可以使用import/export 语法。</p>
<ul>
<li>locations</li>
</ul>
<p>默认值是 false，设置为 true 之后会在 AST 的节点中携带多一个 loc 对象来表示当前的开始和结束的行数和列数。</p>
<ul>
<li>onComment</li>
</ul>
<p>传入一个回调函数，每当解析到代码中的注释时会触发，可以获取当年注释内容，参数列表是：[block, text, start, end]。</p>
<p>block 表示是否是块注释，text 是注释内容，start 和 end 是注释开始和结束的位置。</p>
<p>上边提及的 Espree 需要 Esprima 的 attachComment 的配置项，设置为 true 后，Esprima<br />
会在代码解析结果的节点中携带注释相关信息(trailingComments 和 leadingComments)。Espree 则是利用<br />
Acorn 的  onComment 配置来实现这个 Esprima 特性的兼容。</p>
<p>解析器通常还会有一个获取词法分析结果的接口：</p>
<pre>
</pre>
<ol>
<li>const tokens = [...acorn.tokenizer(code, options)] </li>
</ol>
<p>tokenizer 方法的第二个参数也能够配置 locations。</p>
<p>词法结果 token 和 Esprima 的结果数据结构上有一定的区别(Espree 又是做了这一层的兼容)，有兴趣了解的可以看下 Esprima  的解析结果：<a href="http://esprima.org/demo/parse.html" rel="external nofollow noreferrer">http://esprima.org/demo/parse...</a> 。</p>
<p>至于 Acorn 解析的 AST 和 token 的内容我们接下来详述。</p>
<p><strong>Token</strong></p>
<p>我找了半天，没找到关于 token 数据结构的详细介绍，只能自己动手来看一下了。</p>
<p>我用来测试解析的代码是：</p>
<pre>
</pre>
<ol>
<li>import "hello.js" </li>
<li> </li>
<li>var a = 2; </li>
<li> </li>
<li>// test </li>
<li>function name() { console.log(arguments); }  </li>
</ol>
<p>解析出来的 token 数组是一个个类似这样的对象：</p>
<pre>
</pre>
<ol>
<li>Token { </li>
<li>    type: </li>
<li>     TokenType { </li>
<li>       label: 'import', </li>
<li>       keyword: 'import', </li>
<li>       beforeExpr: false, </li>
<li>       startsExpr: false, </li>
<li>       isLoop: false, </li>
<li>       isAssign: false, </li>
<li>       prefix: false, </li>
<li>       postfix: false, </li>
<li>       binop: null, </li>
<li>       updateContext: null }, </li>
<li>    value: 'import', </li>
<li>    start: 5, </li>
<li>    end: 11 },  </li>
</ol>
<p>看上去其实很好理解对不对，在 type 对应的对象中，label 表示当前标识的一个类型，keyword 就是关键词，像例子中的import，或者  function 之类的。</p>
<p>value 则是当前标识的值，start/end 分别是开始和结束的位置。</p>
<p>通常我们需要关注的就是 label/keyword/value 这些了。其他的详细可以参考源码：tokentype.js。</p>
<p><strong>The Estree Spec</strong></p>
<p>这一部分是重头戏，因为实际上我需要的还是解析出来的 AST。最原滋原味的内容来自于：The Estree Spec，我只是阅读了之后的搬运工。</p>
<p>提供了标准文档的好处是，很多东西有迹可循，这里还有一个工具，用于把满足 Estree 标准的 AST 转换为 ESMAScript  代码：escodegen。</p>
<p>好吧，回到正题，我们先来看一下 ES5 的部分，可以在 Esprima: Parser 这个页面测试各种代码的解析结果。</p>
<p>符合这个规范的解析出来的 AST 节点用 Node 对象来标识，Node 对象应该符合这样的接口：</p>
<pre>
</pre>
<ol>
<li>interface Node { </li>
<li>    type: string; </li>
<li>    loc: SourceLocation | null; </li>
<li>}  </li>
</ol>
<p>type 字段表示不同的节点类型，下边会再讲一下各个类型的情况，分别对应了 JavaScript 中的什么语法。</p>
<p>loc 字段表示源码的位置信息，如果没有相关信息的话为 null，否则是一个对象，包含了开始和结束的位置。接口如下：</p>
<pre>
</pre>
<ol>
<li>interface SourceLocation { </li>
<li>    source: string | null; </li>
<li>    start: Position; </li>
<li>    end: Position; </li>
<li>}  </li>
</ol>
<p>这里的 Position 对象包含了行和列的信息，行从 1 开始，列从 0 开始：</p>
<pre>
</pre>
<ol>
<li>interface Position { </li>
<li>    line: number; // &gt;= 1 </li>
<li>    column: number; // &gt;= 0 </li>
<li>}  </li>
</ol>
<p>好了，基础部分就是这样，接下来看各种类型的节点，顺带温习一下 JavaScript  语法的一些东西吧。对于这里每一部分的内容，会简单谈一下，但不会展开(内容不少)，对 JavaScript 了解的人很容易就明白的。</p>
<p>我觉得看完就像把 JavaScript 的基础语法整理了一遍。</p>
<p><strong>Identifier</strong></p>
<p>标识符，我觉得应该是这么叫的，就是我们写 JS 时自定义的名称，如变量名，函数名，属性名，都归为标识符。相应的接口是这样的：</p>
<pre>
</pre>
<ol>
<li>interface Identifier &lt;: Expression, Pattern { </li>
<li>    type: "Identifier"; </li>
<li>    name: string; </li>
<li>}  </li>
</ol>
<p>一个标识符可能是一个表达式，或者是解构的模式(ES6 中的解构语法)。我们等会会看到 Expression 和 Pattern 相关的内容的。</p>
<p><strong>Literal</strong></p>
<p>字面量，这里不是指 [] 或者 {} 这些，而是本身语义就代表了一个值的字面量，如 1，“hello”, true 这些，还有正则表达式(有一个扩展的  Node 来表示正则表达式)，如 /d?/。我们看一下文档的定义：</p>
<pre>
</pre>
<ol>
<li>interface Literal &lt;: Expression { </li>
<li>    type: "Literal"; </li>
<li>    value: string | boolean | null | number | RegExp; </li>
<li>}  </li>
</ol>
<p>value 这里即对应了字面量的值，我们可以看出字面量值的类型，字符串，布尔，数值，null 和正则。</p>
<p><strong>RegExpLiteral</strong></p>
<p>这个针对正则字面量的，为了更好地来解析正则表达式的内容，添加多一个 regex 字段，里边会包括正则本身，以及正则的flags。</p>
<pre>
</pre>
<ol>
<li>interface RegExpLiteral &lt;: Literal { </li>
<li>  regex: { </li>
<li>    pattern: string; </li>
<li>    flags: string; </li>
<li>  }; </li>
<li>}  </li>
</ol>
<p><strong>Programs</strong></p>
<p>一般这个是作为跟节点的，即代表了一棵完整的程序代码树。</p>
<pre>
</pre>
<ol>
<li>interface Program &lt;: Node { </li>
<li>    type: "Program"; </li>
<li>    body: [ Statement ]; </li>
<li>}  </li>
</ol>
<p>body 属性是一个数组，包含了多个 Statement(即语句)节点。</p>
<p><strong>Functions</strong></p>
<p>函数声明或者函数表达式节点。</p>
<pre>
</pre>
<ol>
<li>interface Function &lt;: Node { </li>
<li>    id: Identifier | null; </li>
<li>    params: [ Pattern ]; </li>
<li>    body: BlockStatement; </li>
<li>}  </li>
</ol>
<p>id 是函数名，params 属性是一个数组，表示函数的参数。body 是一个块语句。</p>
<p>有一个值得留意的点是，你在测试过程中，是不会找到 type: "Function" 的节点的，但是你可以找到 type:<br />
"FunctionDeclaration" 和 type:<br />
"FunctionExpression"，因为函数要么以声明语句出现，要么以函数表达式出现，都是节点类型的组合类型，后边会再提及<br />
FunctionDeclaration 和 FunctionExpression 的相关内容。</p>
<p>这让人感觉这个文档规划得蛮细致的，函数名，参数和函数块是属于函数部分的内容，而声明或者表达式则有它自己需要的东西。</p>
<p><strong>Statement</strong></p>
<p>语句节点没什么特别的，它只是一个节点，一种区分，但是语句有很多种，下边会详述。</p>
<pre>
</pre>
<ol>
<li>interface Statement &lt;: Node { } </li>
</ol>
<p><strong>ExpressionStatement</strong></p>
<p>表达式语句节点，a = a + 1 或者 a++ 里边会有一个 expression 属性指向一个表达式节点对象(后边会提及表达式)。</p>
<pre>
</pre>
<ol>
<li>interface ExpressionStatement &lt;: Statement { </li>
<li>    type: "ExpressionStatement"; </li>
<li>    expression: Expression; </li>
<li>}  </li>
</ol>
<p><strong>BlockStatement</strong></p>
<p>块语句节点，举个例子：if (...) { // 这里是块语句的内容 }，块里边可以包含多个其他的语句，所以有一个 body  属性，是一个数组，表示了块里边的多个语句。</p>
<pre>
</pre>
<ol>
<li>interface BlockStatement &lt;: Statement { </li>
<li>    type: "BlockStatement"; </li>
<li>    body: [ Statement ]; </li>
<li>}  </li>
</ol>
<p><strong>EmptyStatement</strong></p>
<p>一个空的语句节点，没有执行任何有用的代码，例如一个单独的分号 ;</p>
<pre>
</pre>
<ol>
<li>interface EmptyStatement  &lt;: Statement { </li>
<li>    type: "EmptyStatement "; </li>
<li>}  </li>
</ol>
<p>DebuggerStatement</p>
<p>debugger，就是表示这个，没有其他了。</p>
<pre>
</pre>
<ol>
<li>interface DebuggerStatement &lt;: Statement { </li>
<li>    type: "DebuggerStatement"; </li>
<li>}  </li>
</ol>
<p><strong>WithStatement</strong></p>
<p>with 语句节点，里边有两个特别的属性，object 表示 with 要使用的那个对象(可以是一个表达式)，body 则是对应 with  后边要执行的语句，一般会是一个块语句。</p>
<pre>
</pre>
<ol>
<li>interface WithStatement &lt;: Statement { </li>
<li>    type: "WithStatement"; </li>
<li>    object: Expression; </li>
<li>    body: Statement; </li>
<li>}  </li>
</ol>
<p>下边是控制流的语句：</p>
<p><strong>ReturnStatement</strong></p>
<p>返回语句节点，argument 属性是一个表达式，代表返回的内容。</p>
<pre>
</pre>
<ol>
<li>interface ReturnStatement &lt;: Statement { </li>
<li>    type: "ReturnStatement"; </li>
<li>    argument: Expression | null; </li>
<li>}  </li>
</ol>
<p><strong>LabeledStatement</strong></p>
<p>label 语句，平时可能会比较少接触到，举个例子：</p>
<pre>
</pre>
<ol>
<li>loop: for(let i = 0; i &lt; len; i++) { </li>
<li>    // ... </li>
<li>    for (let j = 0; j &lt; min; j++) { </li>
<li>        // ... </li>
<li>        break loop; </li>
<li>    } </li>
<li>}  </li>
</ol>
<p>这里的 loop 就是一个 label 了，我们可以在循环嵌套中使用 break loop 来指定跳出哪个循环。所以这里的 label  语句指的就是loop: ... 这个。</p>
<p>一个 label 语句节点会有两个属性，一个 label 属性表示 label 的名称，另外一个 body 属性指向对应的语句，通常是一个循环语句或者  switch 语句。</p>
<pre>
</pre>
<ol>
<li>interface LabeledStatement &lt;: Statement { </li>
<li>    type: "LabeledStatement"; </li>
<li>    label: Identifier; </li>
<li>    body: Statement; </li>
<li>}  </li>
</ol>
<p><strong>BreakStatement</strong></p>
<p>break 语句节点，会有一个 label 属性表示需要的 label 名称，当不需要 label 的时候(通常都不需要)，便是 null。</p>
<pre>
</pre>
<ol>
<li>interface BreakStatement &lt;: Statement { </li>
<li>    type: "BreakStatement"; </li>
<li>    label: Identifier | null; </li>
<li>}  </li>
</ol>
<p><strong>ContinueStatement</strong></p>
<p>continue 语句节点，和 break 类似。</p>
<pre>
</pre>
<ol>
<li>interface ContinueStatement &lt;: Statement { </li>
<li>    type: "ContinueStatement"; </li>
<li>    label: Identifier | null; </li>
<li>}  </li>
</ol>
<p>下边是条件语句：</p>
<p><strong>IfStatement</strong></p>
<p>if 语句节点，很常见，会带有三个属性，test 属性表示 if (...) 括号中的表达式。</p>
<p>consequent 属性是表示条件为 true 时的执行语句，通常会是一个块语句。</p>
<p>alternate 属性则是用来表示 else 后跟随的语句节点，通常也会是块语句，但也可以又是一个 if 语句节点，即类似这样的结构：</p>
<p>if (a) { //... } else if (b) { // ... }。</p>
<p>alternate 当然也可以为 null。</p>
<pre>
</pre>
<ol>
<li>interface IfStatement &lt;: Statement { </li>
<li>    type: "IfStatement"; </li>
<li>    test: Expression; </li>
<li>    consequent: Statement; </li>
<li>    alternate: Statement | null; </li>
<li>}  </li>
</ol>
<p><strong>SwitchStatement</strong></p>
<p>switch 语句节点，有两个属性，discriminant 属性表示 switch 语句后紧随的表达式，通常会是一个变量，cases 属性是一个case  节点的数组，用来表示各个 case 语句。</p>
<pre>
</pre>
<ol>
<li>interface SwitchStatement &lt;: Statement { </li>
<li>    type: "SwitchStatement"; </li>
<li>    discriminant: Expression; </li>
<li>    cases: [ SwitchCase ]; </li>
<li>}  </li>
</ol>
<p><strong>SwitchCase</strong></p>
<p>switch 的 case 节点。test 属性代表这个 case 的判断表达式，consequent 则是这个 case 的执行语句。</p>
<p>当 test 属性是 null 时，则是表示 default 这个 case 节点。</p>
<pre>
</pre>
<ol>
<li>interface SwitchCase &lt;: Node { </li>
<li>    type: "SwitchCase"; </li>
<li>    test: Expression | null; </li>
<li>    consequent: [ Statement ]; </li>
<li>}  </li>
</ol>
<p>下边是异常相关的语句：</p>
<p><strong>ThrowStatement</strong></p>
<p>throw 语句节点，argument 属性用以表示 throw 后边紧跟的表达式。</p>
<pre>
</pre>
<ol>
<li>interface ThrowStatement &lt;: Statement { </li>
<li>    type: "ThrowStatement"; </li>
<li>    argument: Expression; </li>
<li>}  </li>
</ol>
<p><strong>TryStatement</strong></p>
<p>try 语句节点，block 属性表示 try 的执行语句，通常是一个块语句。</p>
<p>hanlder 属性是指 catch 节点，finalizer 是指 finally 语句节点，当 hanlder 为 null 时，finalizer  必须是一个块语句节点。</p>
<pre>
</pre>
<ol>
<li>interface TryStatement &lt;: Statement { </li>
<li>    type: "TryStatement"; </li>
<li>    block: BlockStatement; </li>
<li>    handler: CatchClause | null; </li>
<li>    finalizer: BlockStatement | null; </li>
<li>}  </li>
</ol>
<p><strong>CatchClause</strong></p>
<p>catch 节点，param 用以表示 catch 后的参数，body 则表示 catch 后的执行语句，通常是一个块语句。</p>
<pre>
</pre>
<ol>
<li>interface CatchClause &lt;: Node { </li>
<li>    type: "CatchClause"; </li>
<li>    param: Pattern; </li>
<li>    body: BlockStatement; </li>
<li>}  </li>
</ol>
<p>下边是循环语句：</p>
<p><strong>WhileStatement</strong></p>
<p>while 语句节点，test 表示括号中的表达式，body 是表示要循环执行的语句。</p>
<pre>
</pre>
<ol>
<li>interface WhileStatement &lt;: Statement { </li>
<li>    type: "WhileStatement"; </li>
<li>    test: Expression; </li>
<li>    body: Statement; </li>
<li>}  </li>
</ol>
<p><strong>DoWhileStatement</strong></p>
<p>do/while 语句节点，和 while 语句类似。</p>
<pre>
</pre>
<ol>
<li>interface DoWhileStatement &lt;: Statement { </li>
<li>    type: "DoWhileStatement"; </li>
<li>    body: Statement; </li>
<li>    test: Expression; </li>
<li>}  </li>
</ol>
<p><strong>ForStatement</strong></p>
<p>for 循环语句节点，属性 init/test/update 分别表示了 for  语句括号中的三个表达式，初始化值，循环判断条件，每次循环执行的变量更新语句(init 可以是变量声明或者表达式)。这三个属性都可以为 null，即  for(;;){}。</p>
<p>body 属性用以表示要循环执行的语句。</p>
<pre>
</pre>
<ol>
<li>interface ForStatement &lt;: Statement { </li>
<li>    type: "ForStatement"; </li>
<li>    init: VariableDeclaration | Expression | null; </li>
<li>    test: Expression | null; </li>
<li>    update: Expression | null; </li>
<li>    body: Statement; </li>
<li>}  </li>
</ol>
<p><strong>ForInStatement</strong></p>
<p>for/in 语句节点，left 和 right 属性分别表示在 in 关键词左右的语句(左侧可以是一个变量声明或者表达式)。body  依旧是表示要循环执行的语句。</p>
<pre>
</pre>
<ol>
<li>interface ForInStatement &lt;: Statement { </li>
<li>    type: "ForInStatement"; </li>
<li>    left: VariableDeclaration |  Pattern; </li>
<li>    right: Expression; </li>
<li>    body: Statement; </li>
<li>}  </li>
</ol>
<p><strong>Declarations</strong></p>
<p>声明语句节点，同样也是语句，只是一个类型的细化。下边会介绍各种声明语句类型。</p>
<pre>
</pre>
<ol>
<li>interface Declaration &lt;: Statement { } </li>
</ol>
<p><strong>FunctionDeclaration</strong></p>
<p>函数声明，和之前提到的 Function 不同的是，id 不能为 null。</p>
<pre>
</pre>
<ol>
<li>interface FunctionDeclaration &lt;: Function, Declaration { </li>
<li>    type: "FunctionDeclaration"; </li>
<li>    id: Identifier; </li>
<li>}  </li>
</ol>
<p><strong>VariableDeclaration</strong></p>
<p>变量声明，kind 属性表示是什么类型的声明，因为 ES6 引入了 const/let。</p>
<p>declarations 表示声明的多个描述，因为我们可以这样：let a = 1, b = 2;。</p>
<pre>
</pre>
<ol>
<li>interface VariableDeclaration &lt;: Declaration { </li>
<li>    type: "VariableDeclaration"; </li>
<li>    declarations: [ VariableDeclarator ]; </li>
<li>    kind: "var"; </li>
<li>}  </li>
</ol>
<p><strong>VariableDeclarator</strong></p>
<p>变量声明的描述，id 表示变量名称节点，init 表示初始值的表达式，可以为 null。</p>
<pre>
</pre>
<ol>
<li>interface VariableDeclarator &lt;: Node { </li>
<li>    type: "VariableDeclarator"; </li>
<li>    id: Pattern; </li>
<li>    init: Expression | null; </li>
<li>}  </li>
</ol>
<p><strong>Expressions</strong></p>
<p>表达式节点。</p>
<pre>
</pre>
<ol>
<li>interface Expression &lt;: Node { } </li>
</ol>
<p><strong>ThisExpression</strong></p>
<p>表示 this。</p>
<pre>
</pre>
<ol>
<li>interface ThisExpression &lt;: Expression { </li>
<li>    type: "ThisExpression"; </li>
<li>}  </li>
</ol>
<p><strong>ArrayExpression</strong></p>
<p>数组表达式节点，elements 属性是一个数组，表示数组的多个元素，每一个元素都是一个表达式节点。</p>
<pre>
</pre>
<ol>
<li>interface ArrayExpression &lt;: Expression { </li>
<li>    type: "ArrayExpression"; </li>
<li>    elements: [ Expression | null ]; </li>
<li>}  </li>
</ol>
<p><strong>ObjectExpression</strong></p>
<p>对象表达式节点，property 属性是一个数组，表示对象的每一个键值对，每一个元素都是一个属性节点。</p>
<pre>
</pre>
<ol>
<li>interface ObjectExpression &lt;: Expression { </li>
<li>    type: "ObjectExpression"; </li>
<li>    properties: [ Property ]; </li>
<li>}  </li>
</ol>
<p>Property</p>
<p>对象表达式中的属性节点。key 表示键，value 表示值，由于 ES5 语法中有 get/set 的存在，所以有一个 kind  属性，用来表示是普通的初始化，或者是 get/set。</p>
<pre>
</pre>
<ol>
<li>interface Property &lt;: Node { </li>
<li>    type: "Property"; </li>
<li>    key: Literal | Identifier; </li>
<li>    value: Expression; </li>
<li>    kind: "init" | "get" | "set"; </li>
<li>}  </li>
</ol>
<p><strong>FunctionExpression</strong></p>
<p>函数表达式节点。</p>
<pre>
</pre>
<ol>
<li>interface FunctionExpression &lt;: Function, Expression { </li>
<li>    type: "FunctionExpression"; </li>
<li>}  </li>
</ol>
<p>下边是一元运算符相关的表达式部分：</p>
<p><strong>UnaryExpression</strong></p>
<p>一元运算表达式节点(++/-- 是 update 运算符，不在这个范畴内)，operator 表示运算符，prefix  表示是否为前缀运算符。argument 是要执行运算的表达式。</p>
<pre>
</pre>
<ol>
<li>interface UnaryExpression &lt;: Expression { </li>
<li>    type: "UnaryExpression"; </li>
<li>    operator: UnaryOperator; </li>
<li>    prefix: boolean; </li>
<li>    argument: Expression; </li>
<li>}  </li>
</ol>
<p>UnaryOperator</p>
<p>一元运算符，枚举类型，所有值如下：</p>
<pre>
</pre>
<ol>
<li>enum UnaryOperator { </li>
<li>    "-" | "+" | "!" | "~" | "typeof" | "void" | "delete" </li>
<li>}  </li>
</ol>
<p><strong>UpdateExpression</strong></p>
<p>update 运算表达式节点，即 ++/--，和一元运算符类似，只是 operator 指向的节点对象类型不同，这里是 update 运算符。</p>
<pre>
</pre>
<ol>
<li>interface UpdateExpression &lt;: Expression { </li>
<li>    type: "UpdateExpression"; </li>
<li>    operator: UpdateOperator; </li>
<li>    argument: Expression; </li>
<li>    prefix: boolean; </li>
<li>}  </li>
</ol>
<p>UpdateOperator</p>
<p>update 运算符，值为 ++ 或 --，配合 update 表达式节点的 prefix 属性来表示前后。</p>
<pre>
</pre>
<ol>
<li>enum UpdateOperator { </li>
<li>  "++" | "--" </li>
<li>}  </li>
</ol>
<p>下边是二元运算符相关的表达式部分：</p>
<p><strong>BinaryExpression</strong></p>
<p>二元运算表达式节点，left 和 right 表示运算符左右的两个表达式，operator 表示一个二元运算符。</p>
<pre>
</pre>
<ol>
<li>interface BinaryExpression &lt;: Expression { </li>
<li>    type: "BinaryExpression"; </li>
<li>    operator: BinaryOperator; </li>
<li>    left: Expression; </li>
<li>    right: Expression; </li>
<li>} </li>
</ol>
<p>BinaryOperator</p>
<p>二元运算符，所有值如下：</p>
<pre>
</pre>
<ol>
<li>enum BinaryOperator { </li>
<li>    "==" | "!=" | "===" | "!==" </li>
<li>         | "&lt;" | "&lt;=" | "&gt;" | "&gt;=" </li>
<li>         | "&lt;&lt;" | "&gt;&gt;" | "&gt;&gt;&gt;" </li>
<li>         | "+" | "-" | "*" | "/" | "%" </li>
<li>         | "|" | "^" | "&amp;" | "in" </li>
<li>         | "instanceof" </li>
<li>}  </li>
</ol>
<p><strong>AssignmentExpression</strong></p>
<p>赋值表达式节点，operator 属性表示一个赋值运算符，left 和 right 是赋值运算符左右的表达式。</p>
<pre>
</pre>
<ol>
<li>interface AssignmentExpression &lt;: Expression { </li>
<li>    type: "AssignmentExpression"; </li>
<li>    operator: AssignmentOperator; </li>
<li>    left: Pattern | Expression; </li>
<li>    right: Expression; </li>
<li>}  </li>
</ol>
<p>AssignmentOperator</p>
<p>赋值运算符，所有值如下：(常用的并不多)</p>
<pre>
</pre>
<ol>
<li>enum AssignmentOperator { </li>
<li>    "=" | "+=" | "-=" | "*=" | "/=" | "%=" </li>
<li>        | "&lt;&lt;=" | "&gt;&gt;=" | "&gt;&gt;&gt;=" </li>
<li>        | "|=" | "^=" | "&amp;=" </li>
<li>}  </li>
</ol>
<p><strong>LogicalExpression</strong></p>
<p>逻辑运算表达式节点，和赋值或者二元运算类型，只不过 operator 是逻辑运算符类型。</p>
<pre>
</pre>
<ol>
<li>interface LogicalExpression &lt;: Expression { </li>
<li>    type: "LogicalExpression"; </li>
<li>    operator: LogicalOperator; </li>
<li>    left: Expression; </li>
<li>    right: Expression; </li>
<li>}  </li>
</ol>
<p>LogicalOperator</p>
<p>逻辑运算符，两种值，即与或。</p>
<pre>
</pre>
<ol>
<li>enum LogicalOperator { </li>
<li>    "||" | "&amp;&amp;" </li>
<li>}  </li>
</ol>
<p><strong>MemberExpression</strong></p>
<p>成员表达式节点，即表示引用对象成员的语句，object 是引用对象的表达式节点，property 是表示属性名称，computed<br />
如果为false，是表示 . 来引用成员，property 应该为一个 Identifier 节点，如果 computed 属性为<br />
true，则是 []  来进行引用，即property 是一个 Expression 节点，名称是表达式的结果值。</p>
<pre>
</pre>
<ol>
<li>interface MemberExpression &lt;: Expression, Pattern { </li>
<li>    type: "MemberExpression"; </li>
<li>    object: Expression; </li>
<li>    property: Expression; </li>
<li>    computed: boolean; </li>
<li>}  </li>
</ol>
<p>下边是其他的一些表达式：</p>
<p><strong>ConditionalExpression</strong></p>
<p>条件表达式，通常我们称之为三元运算表达式，即 boolean ? true : false。属性参考条件语句。</p>
<pre>
</pre>
<ol>
<li>interface ConditionalExpression &lt;: Expression { </li>
<li>    type: "ConditionalExpression"; </li>
<li>    test: Expression; </li>
<li>    alternate: Expression; </li>
<li>    consequent: Expression; </li>
<li>}  </li>
</ol>
<p><strong>CallExpression</strong></p>
<p>函数调用表达式，即表示了 func(1, 2) 这一类型的语句。callee 属性是一个表达式节点，表示函数，arguments  是一个数组，元素是表达式节点，表示函数参数列表。</p>
<pre>
</pre>
<ol>
<li>interface CallExpression &lt;: Expression { </li>
<li>    type: "CallExpression"; </li>
<li>    callee: Expression; </li>
<li>    arguments: [ Expression ]; </li>
<li>}  </li>
</ol>
<p><strong>NewExpression</strong></p>
<p>new 表达式。</p>
<pre>
</pre>
<ol>
<li>interface NewExpression &lt;: CallExpression { </li>
<li>    type: "NewExpression"; </li>
<li>}  </li>
</ol>
<p><strong>SequenceExpression</strong></p>
<p>这个就是逗号运算符构建的表达式(不知道确切的名称)，expressions 属性为一个数组，即表示构成整个表达式，被逗号分割的多个表达式。</p>
<pre>
</pre>
<ol>
<li>interface SequenceExpression &lt;: Expression { </li>
<li>    type: "SequenceExpression"; </li>
<li>    expressions: [ Expression ]; </li>
<li>}  </li>
</ol>
<p><strong>Patterns</strong></p>
<p>模式，主要在 ES6 的解构赋值中有意义，在 ES5 中，可以理解为和 Identifier 差不多的东西。</p>
<pre>
</pre>
<ol>
<li>interface Pattern &lt;: Node { } </li>
</ol>
<p>这一部分的内容比较多，但都可以举一反三，写这个的时候我就当把 JavaScript 语法再复习一遍。这个文档还有<br />
ES2015，ES2016，ES2017<br />
相关的内容，涉及的东西也蛮多，但是理解了上边的这一些，然后从语法层面去思考这个文档，其他的内容也就很好理解了，这里略去，有需要请参阅：The<br />
Estree  Spec。</p>
<p><strong>Plugins</strong></p>
<p>回到我们的主角，Acorn，提供了一种扩展的方式来编写相关的插件：Acorn Plugins。</p>
<p>我们可以使用插件来扩展解析器，来解析更多的一些语法，如 .jsx 语法，有兴趣的看看这个插件：acorn-jsx。</p>
<p>官方表示 Acorn 的插件是用于方便扩展解析器，但是需要对 Acorn  内部的运行极致比较了解，扩展的方式会在原本的基础上重新定义一些方法。这里不展开讲了，如果我需要插件的话，会再写文章聊聊这个东西。</p>
<p>Examples</p>
<p>现在我们来看一下如何应用这个解析器，例如我们需要用来解析出一个符合 CommonJS 规范的模块依赖了哪些模块，我们可以用 Acorn 来解析  require 这个函数的调用，然后取出调用时的传入参数，便可以获取依赖的模块。</p>
<p>下边是示例代码：</p>
<pre>
</pre>
<ol>
<li>// 遍历所有节点的函数 </li>
<li>function walkNode(node, callback) { </li>
<li>  callback(node) </li>
<li> </li>
<li>  // 有 type 字段的我们认为是一个节点 </li>
<li>  Object.keys(node).forEach((key) =&gt; { </li>
<li>    const item = node[key] </li>
<li>    if (Array.isArray(item)) { </li>
<li>      item.forEach((sub) =&gt; { </li>
<li>        sub.type &amp;&amp; walkNode(sub, callback) </li>
<li>      }) </li>
<li>    } </li>
<li> </li>
<li>    item &amp;&amp; item.type &amp;&amp; walkNode(item, callback) </li>
<li>  }) </li>
<li>} </li>
<li> </li>
<li>function parseDependencies(str) { </li>
<li>  const ast = acorn.parse(str, { ranges: true }) </li>
<li>  const resource = [] // 依赖列表 </li>
<li> </li>
<li>  // 从根节点开始 </li>
<li>  walkNode(ast, (node) =&gt; { </li>
<li>    const callee = node.callee </li>
<li>    const args = node.arguments </li>
<li> </li>
<li>    // require 我们认为是一个函数调用，并且函数名为 require，参数只有一个，且必须是字面量 </li>
<li>    if ( </li>
<li>      node.type === 'CallExpression' &amp;&amp; </li>
<li>      callee.type === 'Identifier' &amp;&amp; </li>
<li>      callee.name === 'require' &amp;&amp; </li>
<li>      args.length === 1 &amp;&amp; </li>
<li>      args[0].type === 'Literal' </li>
<li>    ) { </li>
<li>      const args = node.arguments </li>
<li> </li>
<li>      // 获取依赖的相关信息 </li>
<li>      resource.push({ </li>
<li>        string: str.substring(node.range[0], node.range[1]), </li>
<li>        path: args[0].value, </li>
<li>        start: node.range[0], </li>
<li>        end: node.range[1] </li>
<li>      }) </li>
<li>    } </li>
<li>  }) </li>
<li> </li>
<li>  return resource </li>
<li>}  </li>
</ol>
<p>这只是简单的一个情况的处理，但是已经给我们呈现了如何使用解析器，Webpack 则在这个的基础上做了更多的东西，包括 var r = require;  r('a') 或者 require.async('a') 等的处理。</p>
<p>AST 这个东西对于前端来说，我们无时无刻不在享受着它带来的成果(模块构建，代码压缩，代码混淆)，所以了解一下总归有好处。</p>
<p>作者：teabyii</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-14 08:16:19</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/type/" title="type">type</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/node/" title="node">node</a>, <a href="https://www.iamivan.net/tag/javascript/" title="javascript">javascript</a>, <a href="https://www.iamivan.net/tag/%e6%ad%a3%e5%88%99%e8%a1%a8%e8%be%be%e5%bc%8f/" title="正则表达式">正则表达式</a>, <a href="https://www.iamivan.net/tag/%e8%a1%a8%e8%be%be%e5%bc%8f/" title="表达式">表达式</a>, <a href="https://www.iamivan.net/tag/pattern/" title="pattern">pattern</a>, <a href="https://www.iamivan.net/tag/test/" title="test">test</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用Acorn来解析JavaScript的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boR2Lvz.html" rel="bookmark">全面解析JavaScript中&OpenCurlyDoubleQuote;&amp;amp&semi;&amp;amp&semi;&rdquo;和&OpenCurlyDoubleQuote;&vert;&vert;&rdquo;操作符&lpar;总结篇&rpar;&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.||(逻辑或), 从字面上来说,只有前后都是false的时候才返回false,否则返回true. alert(true||false); // true alert(false||true); // true alert(true||true); // true alert(false||false); // false 这个傻子都知道~~ 但是,从深层意义上来说的话,却有另一番天地,试下面代码 alert(0||1);//1 显然,我们知道,前面0意味着false,而后面1意味着true,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1kjKb.html" rel="bookmark">解析javascript图片懒加载与预加载的分析总结&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇文章主要介绍了懒加载和预加载两种技术的解析,废话不多说,一起来看吧. 懒加载也叫延迟加载:前一篇文章有介绍:JS图片延迟加载 延迟加载图片或符合某些条件时才加载某些图片. 预加载:提前加载图片,当用户需要查看时可直接从本地缓存中渲染. 两种技术的本质:两者的行为是相反的,一个是提前加载,一个是迟缓甚至不加载.懒加载对服务器前端有一定的缓解压力作用,预加载则会增加服务器前端压力. 懒加载的意义及实现方式有: 意义: 懒加载的主要目的是作为服务器前端的优化,减少请求数或延迟请求数. 实现方式:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrddjz.html" rel="bookmark">深度解析javascript中的浅复制和深复制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     在谈javascript的浅复制和深复制之前,我们有必要在来讨论下js的数据类型.我们都知道有 Number,Boolean,String,Null,Undefined,Object五种类型.而Object又包含Function,Array 和Object自身.前面的五种类型叫做基本类型,而Object是引用类型.可能有人就要问,为什么要分基本类型和引用类型呢?后面你就会明白的.      我们首先来看看浅复制和深复制的简洁定义: 深复制:直接将数据复制给对应的变量 浅复制:将数据的地			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2yKnVz.html" rel="bookmark">解析JavaScript中instanceof对于不同的构造器或许都返回true</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 这篇文章主要是对JavaScript中instanceof对于不同的构造器或许都返回true进行了详细的解析,需要的朋友可以过来参考下,希望对大家有所帮助 我们知道 instanceof 运算符用来检查对象是否为某构造器的实例.下面列举它返回true的各种情景.   1.对象obj是通过new Constructor创建的,那么 obj instanceof Constructor 为true     代码如下: function Person(n, a) {      this.name =			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYRE39p.html" rel="bookmark">深入解析JavaScript的闭包机制&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript 变量可以是局部变量或全局变量. 私有变量可以用到闭包.全局变量 函数可以访问是有函数内部定义的变量,如: 实例 function myFunction() { var a = 4; return a * a; } 函数也可以访问函数外部定义的变量,如: 实例 var a = 4; function myFunction() { return a * a; } 后面一个实例中, a 是一个 全局 变量. 在web页面中全局变量属于 window 对象. 全局变量可应用于页面上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNX3Bp.html" rel="bookmark">深入解析JavaScript编程中的this关键字使用&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript 里的 this 到底指得是什么?很多人都会告诉你 this 指的是当前对象.这样理解对么?在大多数情况下确实没错.比如我们经常会在网页上写这样的 JavaScript: &lt;input type=&quot;submit&quot; value=&quot;提交&quot; onclick=&quot;this.value='正在提交数据'&quot; /&gt; 这里的this显然指的是当前对象,即这个提交按钮.通常,我们使用this的情况都与此类似.但是有什么情况不是这样的呢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1joob.html" rel="bookmark">深入解析JavaScript中的数字对象与字符串对象&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript Number 对象JavaScript 只有一种数字类型. 可以使用也可以不使用小数点来书写数字.JavaScript 数字 JavaScript 数字可以使用也可以不使用小数点来书写: 实例 var pi=3.14; // 使用小数点 var x=34; // 不使用小数点 极大或极小的数字可通过科学(指数)计数法来写: 实例 var y=123e5; // 12300000 var z=123e-5; // 0.00123 所有 JavaScript 数字均为 64 位			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBkLYKM.html" rel="bookmark">全面解析JavaScript的Backbone&period;js框架中的Router路由&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Backbone 中的 Router 充当路由的作用,控制 URL 的走向,当在 URL 中使用 # 标签时生效. 定义 Router 至少需要一个 Router 和一个函数来映射特定的 URL,而且我们需要记住,在 Backbone 中,# 标签后的任意字符都会被 Router 接收并解释. 下面我们来定义一个 Router: &lt;script&gt; var AppRouter = Backbone.Router.extend({ routes: { &quot;*actions&quot;: &			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOno29p.html" rel="bookmark">解析JavaScript中的字符串类型与字符编码支持&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				定义字符串就是零个或多个排在一起的字符,放在单引号或双引号之中. 'abc' &quot;abc&quot; 单引号字符串的内部,可以使用双引号.双引号字符串的内部,可以使用单引号. 'key = &quot;value&quot;' &quot;It's a long journey&quot; 上面两个都是合法的字符串. 如果要在单引号字符串的内部,使用单引号(或者在双引号字符串的内部,使用双引号),就必须在内部的单引号(或者双引号)前面加上反斜杠,用来转义. 'Did she say \'Hello			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqW3Kz.html" rel="bookmark" class="title">编译错误-出现了fatal exception ：main 这是其中的一段代码，大家看看有什么问题</a>
					<div>
						问题描述 出现了fatal exception :main 这是其中的一段代码,大家看看有什么问题 public void onCreate(Bundle savedInstanceState) {  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4RmNM.html" rel="bookmark" class="title">Java Thread Programming 1&period;8&period;2 - Inter-thread Communication</a>
					<div>
						  Missed Notification A missed notification occurs when threadB tries to notify threadA, but threadA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwrWvp.html" rel="bookmark" class="title">一个论坛凭什么能留住人？</a>
					<div>
						一个论坛.一个版块能留住会员的因素是多方面的,但是其中很重要的一点就是对版块的经营观念,有一些版主认为要想留住会员必需得发一些有吸引力的帖子才行.所以有些版主在论坛兴建的初期拼命写作,绞尽脑汁要码出一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZ8O4M.html" rel="bookmark" class="title">Photoshop教程&colon;制作被霜覆盖的冰冷效果</a>
					<div>
						本教程来自:digitalartsonline.co.uk/ 如需转载 请务必以超链接形式注明:来自活 力盒 子网站以及原文出处.水平有限,翻译难免有误,请有心的朋友给予指出,以方便更多朋友阅读. 制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyQrJM.html" rel="bookmark" class="title">SEO是一个需要营销策略与思维的高度整合性技术</a>
					<div>
						最近在群里跟朋友们聊天,发现大家很少去学习,去听课了,他们总觉得SEO就那么一点东西,说来说去,学来学去也就那些东西.搜索引擎又不是天天发疯,只要一段时间监控一下数据就好了.看到他们这样说我有点无语, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7v55b.html" rel="bookmark" class="title">XHTML框架结构标签</a>
					<div>
						 框架结构标签&lt;frameset&gt;&lt;/frameset&gt;       框架允许你在一个浏览器窗口内打开两个乃至多个页面.你可以这样理解,&lt;frameset&gt;其实就是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd71vXM.html" rel="bookmark" class="title">迅雷加载项会导致IE9浏览器崩溃</a>
					<div>
						相信很多网友今天启动电脑后的第一件时间就是下载IE9beta,看到IE浏览器的新界面以后感觉确实比之前的版本要简洁很多,色彩的搭配也更加舒服了.安装完毕以后立即打开浏览器体验,随便输入了一个网页打开即 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wgd1p.html" rel="bookmark" class="title">Javascript监视变量变化的方法</a>
					<div>
						  本文实例讲述了Javascript监视变量变化的方法.分享给大家供大家参考.具体分析如下: 大家应该知道,在C#中对于属性.文件等的更改监视非常简单,因为有委托(事件).FileSystemWat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RVKjp.html" rel="bookmark" class="title">PhotoShop手绘教程之言情插画男生皮肤的画法</a>
					<div>
						些教程是进阶篇,不懂工具的纯新手请无视(罪过,下次再做详细的) 我一直搞不懂姑娘们口中的水嫩皮肤是什么概念,其实我想说,全柔边画笔真的是一个很好用的工具. 又有人会说,太柔了,都糊了. 请问,你把边边 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Wvynb.html" rel="bookmark" class="title">U盘里面的word文档无法打开了怎么办</a>
					<div>
						  U盘装系统本来就是用来存储东西的工具,而且对于很多上班一族的人来说,经常需要使用到U盘来传输文件,但是若是不巧,让你遇上U盘中的word文件无法打开了,你知道该如何处理吗?如果你还不知道的话,就和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42narM.html" rel="bookmark" class="title">Android 高手进阶之自定义View，自定义属性（带进度的圆形进度条）</a>
					<div>
						很多的时候,系统自带的View满足不了我们功能的需求,那么我们就需要自己来自定义一个能满足我们需求的View,自定义View我们需要先继承View,添加类的构造方法,重写父类View的一些方法,例如o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PY2Vp.html" rel="bookmark" class="title">Android中的状态机 机制</a>
					<div>
						 前面说过消息注册机制是MessageHandler的一个应用,它的好处就是能在程序中自如地控制消息注册和消息发送两个步骤. 但是很多情况下,问题的解决是在很多个环节完成的,每个环节理解成特定的状态, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PVZ4p.html" rel="bookmark" class="title">【感想】DTCC大会有感</a>
					<div>
						 好久没有沉淀文章了,感谢ITPUB 论坛赠送门票,4.15-4.18  去北京参加了DTCC 大会,没有能够全部参加所有的场次,选择了其中自己感兴趣的场次,主要是偏运维 和MySQL ,Oracle ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVNoWkz.html" rel="bookmark" class="title">D3D9学习笔记&lpar;七&rpar; TEXTURE 纹理</a>
					<div>
						texture永远是图形学最精华细节最多的地方,所以我也花了最多的时间阅读和写这个章节.   d3dDevice-&gt;SetTexture(n,tex)设置当前在n通道的texture,n的数量硬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NX37z.html" rel="bookmark" class="title">xcode-在UIStoryboard应用中跳转ViewController</a>
					<div>
						问题描述 在UIStoryboard应用中跳转ViewController 应用是Xcode 4.5版本,用到了UIStoryboard. 其中有第一个ViewController 推入到第二个Vie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwrKKM.html" rel="bookmark" class="title">ps修复严重偏蓝的风景照片</a>
					<div>
						原始图 效果图 教程步骤如下1.打开原图,新建图层,shift+F5填充50%灰色   2.将填充的灰色图层改为&quot;差值&quot;混合模式   分类: PS图片处理					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZEoxwp.html" rel="bookmark" class="title">从小米&OpenCurlyDoubleQuote;空净质量门&rdquo;，看智能家居如何战略聚焦</a>
					<div>
						战略聚焦,发挥自己的强项,才能在下一个风口找到合适的落脚点. 小米又一次陷入&quot;质量门&quot;事件. 上周,上海质监局发布了一份空气净化器质量抽查报告,其中有包括小米等公司在内的4批次产品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjxnQp.html" rel="bookmark" class="title">c&plus;&plus;-新人求助 关于网络编程的思路问题</a>
					<div>
						问题描述 新人求助 关于网络编程的思路问题 用多网卡电脑作为服务器,不同网卡设置不同网段的IP,分别采用tcp,udp 和组播协议进行通信.网卡固定对应一种协议,例如网卡A上采用tcp协议. 求问大神 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Z3xgM.html" rel="bookmark" class="title">android-主动请求蓝牙配对（Android）</a>
					<div>
						问题描述 主动请求蓝牙配对(Android) 我现在已经得到了附近蓝牙设备BluetoothDevice,怎么主动发送配对请求,在网上找了许多答案,但是好像都是一些聊天方面的内容要用到Bluetoot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z402NPz.html" rel="bookmark" class="title">联络家要改变的是使用性和简易性</a>
					<div>
						很多的朋友都比较关注联络家,也一直有朋友给我留言探讨联络家的需要该进的地方,在这种沟通交流中真的碰出了很多思想的火花. 有朋友认为联络家应该把一个人的所 有信息都组织到联络家上,然后通过权限设置控制信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm5NVb.html" rel="bookmark" class="title">地址总线-32位的系统为什么最大内存4G？应该是最大4G个地址啊</a>
					<div>
						问题描述 32位的系统为什么最大内存4G?应该是最大4G个地址啊 就是说32根地址总线,每根总线上两种状态0或1,那么就可以有2^32个地址. 然后我看很多文章说因为2^32等于4G,所以最大就4G. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBne0M.html" rel="bookmark" class="title">杂项函数库：show&lowbar;source</a>
					<div>
						show_source (PHP4) show_source ---&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydXa4b.html" rel="bookmark" class="title">《深入理解Android》一3&period;7　本章小结</a>
					<div>
						3.7 本章小结 本章主要介绍了WTF库的实现与使用,包括其中的OwnPtr.RefPtr.断言.内存管理.容器.原子操作等内容,为读者继续阅读及实际开发提供支持.同时,还介绍了Android 的cr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZK2Rp.html" rel="bookmark" class="title">Adobe推出网络版Photoshop</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 Web版Photoshop ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnJ38M.html" rel="bookmark" class="title">ESG：浅析思科进军服务器市场行业影响</a>
					<div>
						本文讲的是ESG:浅析思科进军服务器市场行业影响,导语:Steve Duplessie,作为ESG (www.enterprisestrategygroup.com) 的创始人兼首席分析师, 被视为全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwJP1M.html" rel="bookmark" class="title">javascript-我想用JavaScript改变td的colspan的值&period;为什么无法改变&quest;</a>
					<div>
						问题描述 我想用JavaScript改变td的colspan的值.为什么无法改变? &lt;!DOCTYPE html&gt;&lt;html&gt;&lt;head&gt;&lt;script ty ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQy9Kp.html" rel="bookmark" class="title">ua-求教python requests&period;get中传多个UA的问题</a>
					<div>
						问题描述 求教python requests.get中传多个UA的问题 如题. 因为被重定向,所以写了用多个UA来获取网页源码,不是很清楚是不是只要在header中写个UA字典然后request.ge ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRN6JxM.html" rel="bookmark" class="title">【微软】微软发布开发代号为 &OpenCurlyDoubleQuote;Data Explorer&rdquo;的数据管理工具</a>
					<div>
						微软今天在SQL http://www.aliyun.com/zixun/aggregation/13357.html&quot;&gt;Azure Lab发表了一个新工具,目前正在招募测试人员,它的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JKw3z.html" rel="bookmark" class="title">黑客攻击索尼事件水落石出？</a>
					<div>
						他们几乎怀疑每一个人,从索尼前员工到俄罗斯犯罪分子,再到一个名为&quot;Lizard Squad&quot;的视频游戏爱好者组织. 对于类似本次事件的大规模网络攻击,要找出谁是幕后真凶并不容易.攻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z4Emz.html" rel="bookmark" class="title">Win7 下注册COM组件 提示DLLRegisterServer调用失败</a>
					<div>
						问题描述 尝试多种解决方法,最后在控制面板下做如下修改,即可注册:					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.065 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
